//VARIABLES

let cols; //Create variables for columns of shapes
let rows; //Create variable for rows of shapes
let scale = 20 //Create variable for scale
let w = 1400; //Create variable for width of shape repitition
let h = 1200; //Create variable for height of shape repitition

let flying = 0; //Set variable for flying
let shapes = []; //Set Array

let song; //Set variable for loading song 1
let backgroundColour = 255; //Set background to dark grey
let switchMode = 1; //Set variable for switchmode
let g = 255
let b = 255



//LOAD SONGS

function preload() { //Create funtion for loading songs

  song = loadSound("../Songs/Phase1.mp3"); //Preload sound 1 file to play later in program

}



//SET UP

function setup() { //Create Setup Function
  createCanvas(1000, 700, WEBGL); //Create 3D canvas using WEBGL
  getAudioContext().suspend();

  song.play();

  cols = w / scale; //Create columns based on screenwidth
  rows = h / scale; //Create rows based on screen

  for (let x = 0; x < cols; x++) { //Set loop statement to call in array
    shapes[x] = []; //Call array to display shapes
  }
}



//DRAW 

function draw() { //Set Function to Draw

  flying -= 0.1; //Set Flying Angle on orbs
  let yoff = flying; //Set Flying height from orbs

  for (let y = 0; y < rows; y++) { //Set first row peak

    let xoff = 0; //Create variable for peaks

    for (let x = 0; x < cols; x++) { //Set repeating row peak height

      shapes[x][y] = map(noise(xoff, yoff), 0, 1, -20, 120); //set shapes to move up and down
      xoff += 0.4; //Set height of peak
    }
    yoff += 0.2; //Set speed of peak movement
  }


  //DRAW PHASES



  switch (switchMode) { //Set command for changing states


    //PHASE 1

    case "1": //Set key 1 as 1st phase


      let Phase1Scl = 20; //Set Phase 1 scale for both x and y

      background(backgroundColour, g, b); //Set background colour

      rotateX(PI / 2.1); //Set rotation of view
      stroke(255, random(100, 200), random(150, 160)); //Set colour of orbs in sequence
      strokeWeight(3); //Change size of orbs

      translate(-w / 2, -h / 2); //Set place to view sequence
      for (let y = 0; y < rows - 1; y++) { //Sets rows of orbs

        beginShape(POINTS); //Call shape to become part of grid

        for (let x = 0; x < cols; x++) { //adds collumns to orbs to make the box effect
          vertex(x * Phase1Scl, y * Phase1Scl, shapes[x][y]); //Using variables make shape
        }

        endShape(); //End repitition of shape

      }


      break; //End phase


    //PHASE 2

    case "2": //Set key 2 as 2nd phase

      let phase2Scl = 20 //Set phase 2 scale for both x and y

      background(backgroundColour, g, b);; //Set background colour
      rotateX(PI / 2.5); //Set rotation of view
      strokeWeight(0.5); //Set weight of lines in sequence
      stroke(random(240, 255), random(230, 250), 140); //Set colour of line in sequence
      fill(backgroundColour, g, b); //Fill in sequence


      translate(-w / 2, -h / 1.1); //Set place to view sequence
      for (let y = 0; y < rows - 1; y++) { //Sets rows of Triangle Strip

        beginShape(TRIANGLE_STRIP); //Call shape to become part of grid

        for (let x = 0; x < cols; x++) { //adds collumns to triangle strip to make the box effect
          vertex(x * phase2Scl, y * phase2Scl, shapes[x][y]); //Using variables make shape
          vertex(x * phase2Scl, (y + 1) * phase2Scl, shapes[x][y + 1]); //Using variables make shape
        }

        endShape(); //End repitition of shape

      }

      break; //End phase


    //PHASE 3

    case "3": //Set key 3 as 3rd phase


      let phase3SclX = 30; //Set phase 3 scale for x
      let phase3SclY = 50; //Set phase 3 scale for y

      background(backgroundColour, g, b); //Set background colour
      rotateX(PI / 1.5); //Set rotation of view
      strokeWeight(2);  //Set thickness of line in sequence
      stroke(random(100, 200), random(150, 160), 255); //Set colour of sequence


      translate(-w / 2, -h / 2); //Set place to view sequence
      for (let y = 0; y < rows - 2; y++) { //Sets rows of orbs

        beginShape(QUADS); //Call shape to become part of grid

        for (let x = 0; x < cols; x++) { //adds collumns to orbs to make the box effect
          vertex(x * phase3SclX, y * phase3SclY, shapes[x][y]); //Using variables make shape
        }

        endShape(); //End repitition of shape

      }

      break; //End phase

  }

}

function mousePressed() { //Set function for pressing mouse
  userStartAudio(); //Start playing sound upon mouse click
}

function keyPressed() { //Set function for keys being pressed

  if (keyCode === 49) { //Set mode using key 1
    switchMode = "1"; //Change value to key 1
  } else if (keyCode === 50) { //Set mode using key 2
    switchMode = "2"; //Change value to key 2
  } else if (keyCode === 51) { //Set mode using key 3
    switchMode = "3"; //Change value to key 3
  }

  if (keyCode === 65) { //set background colour using A key
    backgroundColour = 255; //Set background colour to black
    g = 255; //Set g to same as background colour
    b = 255; //Set b to same as background colour

  } else if (keyCode === 66) { //set background colour using B key
    backgroundColour = 0; //Set background colour to White
    g = 0; //Set g to same as background colour
    b = 0; //Set b to same as background colour
  } else if (keyCode === 69) { //set background colour using B key
    backgroundColour = random(0, 255); //Set background colour to White
    g = random(0, 255); //Set g to random value
    b = random(0, 255); //Set b to random value
  }

}